pro nmc_xy_u,ilev1,ilev2

  common data_wrf,znu,znw,zs,uu,vv,ww,press,pb,ph,phb,xlat,xlon,xlat_u,xlon_u,xlat_v,xlon_v,xland_mask,xtopo,rainc,   $
    rainnc,sst,pblh,qvapor,qice,qsnow,qrain,qgraupel,qcloud,qnrain,qnice,geopot,p_hpa,zgeo,glon,glat,glon_u,   $
    glat_u,glon_v,glat_v,topo,temp,landmask,xtn,ytn
  common ids,id_landmask,id_topo,id_lon,id_lat,id_lonu,id_latu,id_lonv,id_latv,id_znu,id_znw,id_zs,   $
    id_u,id_v,id_w,id_p,id_pb,id_ph,id_phb,id_rainc,id_rainnc,id_rainsh,id_sst,id_pbl,   $
    id_u10,id_v10,id_t2,id_q2,id_qvapor,id_qrain,id_qice,id_qgraupel,id_qcloud,id_qsnow,   $
    id_qnrain,id_qnice
  common struct,bckg_wrf,bckgz_wrf,bckgp_wrf,nx,ny,nz,nzs,nx_u,ny_u,nx_v,ny_v,np,nzz,nzm1,delta_x,delta_y
  common constants,amiss,grav,dir,dir_ps,rgas,cp,rovercp,rwi,cpoverr,p00



;; si prendono 2 liste di file 1 con inizializzata al tempo 12 e l'altra al tempo 00 che verificano allo stesso tempo.
dir='/data2/inmc/'
dir_t00='/data1/wivern/'
dir_t12='/data1/wivern/'

;;;;;;;;
amiss=-999.
grav=9.81
rgas=287.
rw=461.
cp=1004.
p00=1000.
rovercp=rgas/cp
cpoverr=cp/rgas
alvl=2.5*1.e6
;;;;;;
nfile=49
date_ini='20200916120000'
delta_h_sim=12.
delta_h=24.

flname1=strarr(nfile)
flname2=strarr(nfile)
for ifile=0,nfile-1 do begin
  ch_mem=string(ifile,'(I2.2)')
  dir_file1=dir_t00+'sim_'+ch_mem+'_42_3dv_wivn_35km_3h'
  ch_mem=string(ifile+1,'(I2.2)')
  dir_file2=dir_t12+'sim_'+ch_mem+'_42_3dv_wivn_35km_3h'
  date_add,date_in=date_ini,delta_h=delta_h,date_out=date_out
  date_f1=date_out
;  date_dir1=date_ini
;  date_add,date_in=date_ini,delta_h=0.5*delta_h,date_out=date_out
  date_f2=date_out
;  date_dir2=date_out
  ;print,date_f1,' ',date_f2
;  date_add,date_in=date_ini,delta_h=0.5*delta_h,date_out=date_out
;  date_ini=date_out
  flname1(ifile)=dir_file1+'/wrfout_d01_'+strmid(date_f1,0,4)+'-'+strmid(date_f1,4,2)+'-'+strmid(date_f1,6,2)+   $
    '_'+strmid(date_f1,8,2)+':'+strmid(date_f1,10,2)+':'+strmid(date_f1,12,2)
  flname2(ifile)=dir_file2+'/wrfout_d01_'+strmid(date_f1,0,4)+'-'+strmid(date_f1,4,2)+'-'+strmid(date_f1,6,2)+   $
    '_'+strmid(date_f1,8,2)+':'+strmid(date_f1,10,2)+':'+strmid(date_f1,12,2)
    print,ifile,' a) ',flname1(ifile),'      b) ',flname2(ifile)
endfor

for ifile=0,nfile-1 do begin
read_wrf,flname1(ifile),0,2
read_wrf,flname2(ifile),1,2

;print,nx,ny,nz
nzm1=nz-1
;print,size(bckg_wrf.qvapor)
if(ifile eq 0) then diff_field=fltarr(nx,ny,nzm1,nfile)
;print,bckg_wrf.qvapor(*,*,0,0)
;print,bckg_wrf.qvapor(*,*,0,1)
;help,bckg_wrf.uu(*,*,0,1)
for iz=0,nzm1-1 do begin 
diff_field(*,*,iz,ifile)=((bckg_wrf.uu([0:nx-1],*,iz,1)-bckg_wrf.uu([0:nx-1],*,iz,0)))       $
                  -((total(bckg_wrf.uu([0:nx-1],*,iz,1))/(nx*ny)-total(bckg_wrf.uu([0:nx-1],*,iz,0))/(nx*ny)))
;print,diff_field(*,*,0,ifile)
endfor
endfor

;;; iniziamo a raggruppare i file per la distanza
nbin=30
dx_bin=12.   ;;; spaziatura in bin dei km
d_bin=fltarr(nbin)
d_bin_half=fltarr(nbin)

bckg=fltarr(nbin,nzm1)
ndata_bin=fltarr(nbin,nzm1)
bckg(*,*)=0.
ndata_bin(*,*)=0.

print,'...................nzm1: ',nzm1
d_bin(0)=0.
d_bin_half(0)=0.
for i=1,nbin-1 do begin
  d_bin(i)=dx_bin+d_bin(i-1)
  d_bin_half(i)=0.5*(d_bin(i-1)+d_bin(i))
endfor

tic
ijfact=3
free_lun,1
;;; calcola le distanze
for iz=ilev1,ilev2 do begin
  openw,1,dir+'out_data/nmc_u_xy_lev_'+string(iz,'(I2.2)')+'.dat'
      somma=0.
      icx=0.
;for ifile=0,nfile-1 do begin
for j1=0,ny-1,ijfact do begin
  for i1=0,nx-1,ijfact do begin

   for j=0,ny-1,ijfact do begin
    for i=0,nx-1,ijfact do begin
for ifile=0,nfile-1 do begin
      dist_ij=1.e-3*sqrt(((i-i1)*delta_x)^2.+((j-j1)*delta_y)^2.)    ;;; riportata in km. Le uscite di WRF sono in m.
      for ibin=0,nbin-2 do begin
        if(dist_ij gt d_bin(ibin) and dist_ij lt d_bin(ibin+1)) then begin
          bckg(ibin,iz)=bckg(ibin,iz)+diff_field(i,j,iz,ifile)*diff_field(i1,j1,iz,ifile)
          ndata_bin(ibin,iz)=ndata_bin(ibin,iz)+1.
         endif
      endfor
      if(dist_ij gt d_bin(nbin-1) ) then BEGIN
        bckg(nbin-1,iz)=bckg(nbin-1,iz)+diff_field(i,j,iz,ifile)*diff_field(i1,j1,iz,ifile)
;        if(diff_field(i,j,iz,ifile)*diff_field(i1,j1,iz,ifile) lt 0. ) then print,diff_field(i,j,iz,ifile),diff_field(i1,j1,iz,ifile)
        ndata_bin(nbin-1,iz)=ndata_bin(nbin-1,iz)+1.
        endif
        if(dist_ij eq 0.) then begin
          somma=somma+diff_field(i,j,iz,ifile)*diff_field(i1,j1,iz,ifile)
          icx=icx+1.
        endif
endfor
    endfor
   endfor
  endfor
;  print,j1,ifile,iz,bckg(*,iz)
;  print,ndata_bin(*,iz)
  print,j1,ny,ifile
  print,bckg(*,iz)/ndata_bin(*,iz),icx,somma/icx

  toc
endfor
;endfor
;;; la stampa va fatta in modo che lo 0 sia somma e icx
for ibin=0,nbin-1 do begin 
if(ibin eq 0) then begin
printf,1,fo='(4(f14.3,1x),E11.4)',somma,icx,d_bin(ibin),d_bin_half(ibin),somma/icx
endif else begin
printf,1,fo='(4(f14.3,1x),E11.4)',bckg(ibin,iz),ndata_bin(ibin,iz),d_bin(ibin),d_bin_half(ibin),bckg(ibin,iz)/ndata_bin(ibin,iz)
endelse
endfor
close,1
endfor

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro read_wrf,flname,ifile,nfile

  common data_wrf
  common ids
  common struct
  common constants

;  NCDF_LIST, flname, /VARIABLES  , /DIMENSIONS  , /GATT, /VATT

  id = NCDF_OPEN(flname)

  ;;;; come si leggono gli attributi.
  
  NCDF_ATTGET,id,'DX',delta_x,/global
  NCDF_ATTGET,id,'DY',delta_y,/global
  
  id_landmask = NCDF_VARID(id, 'XLAND')     ;;; frazione terra mare
  id_topo = NCDF_VARID(id, 'HGT')   ;; TOPOGRAFIA

  id_lon = NCDF_VARID(id, 'XLONG')  ;; longitudine al centro della griglia
  id_lat = NCDF_VARID(id, 'XLAT')   ;; latitudine al centro della griglia
  id_lonu = NCDF_VARID(id, 'XLONG_U')  ;; longitudone ai punti U
  id_latu = NCDF_VARID(id, 'XLAT_U')   ;; latitudine ai punti U
  id_lonv = NCDF_VARID(id, 'XLONG_V')  ;; longitudine ai punti V
  id_latv = NCDF_VARID(id, 'XLAT_V')   ;; latitudine ai punti V

  id_znu= NCDF_VARID(id, 'ZNU')   ;; latitudine ai punti V
  id_znw = NCDF_VARID(id, 'ZNW')   ;; latitudine ai punti V
  id_zs = NCDF_VARID(id, 'ZS')   ;; latitudine ai punti V

  id_slp= NCDF_VARID(id, 'slp')   ;; sea level pressure

  ;;;; VARIABILI 3D
  id_u = NCDF_VARID(id, 'U')           ;; u
  id_v = NCDF_VARID(id, 'V')           ;; v
  id_w = NCDF_VARID(id, 'W')           ;; w

  id_p = NCDF_VARID(id, 'P')           ;; perturbation pressure
  id_pb = NCDF_VARID(id, 'PB')           ;; base state pressure

  id_p_top = NCDF_VARID(id, 'P_TOP')           ;;  SFC_PRESSURE
  id_p_sfc = NCDF_VARID(id, 'PSFC')           ;;  SFC_PRESSURE

  id_c3h = NCDF_VARID(id, 'C3H')           ;;  c4h = (eta-bh)*(p0-pt)+pt
  id_c4h = NCDF_VARID(id, 'C4H')           ;;  c4h = (eta-bh)*(p0-pt)+pt
  id_c3f = NCDF_VARID(id, 'C3F')           ;;  c4h = (eta-bh)*(p0-pt)+pt
  id_c4f = NCDF_VARID(id, 'C4F')           ;;  c4h = (eta-bh)*(p0-pt)+pt

  id_pcb = NCDF_VARID(id, 'PCB')           ;; dry pressure at the surface perturbation pressure
  id_pc = NCDF_VARID(id, 'PC')             ;; perturbation dry pressure at the surface

  id_ph = NCDF_VARID(id, 'PH')           ;; perturbation geopotential height
  id_phb = NCDF_VARID(id, 'PHB')           ;; base state geopotential height

  id_z = NCDF_VARID(id, 'z')           ;; base state geopotential height

  id_ztd = NCDF_VARID(id, 'ZTD')     ;;; ZTD
  id_ztd_dry = NCDF_VARID(id, 'ZTD_DRY')     ;;; ZTD_DRY


  ;;; VARIABILI 2D
  id_rainc = NCDF_VARID(id, 'RAINC')   ;; Pioggia convettiva accumulata dall'inizio del run
  id_rainnc = NCDF_VARID(id, 'RAINNC') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_rainsh = NCDF_VARID(id, 'RAINSH') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  id_sst = NCDF_VARID(id, 'SST') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_pbl = NCDF_VARID(id, 'PBLH') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  id_u10 = NCDF_VARID(id, 'U10') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_v10 = NCDF_VARID(id, 'V10') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  id_psfc = NCDF_VARID(id, 'PSFC') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  id_t2 = NCDF_VARID(id, 't2') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_q2 = NCDF_VARID(id, 'q2') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  ;;;; grandezze microfisiche
  id_qvapor = NCDF_VARID(id, 'QVAPOR') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qrain = NCDF_VARID(id, 'QRAIN') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qsnow = NCDF_VARID(id, 'QSNOW') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qcloud = NCDF_VARID(id, 'QCLOUD') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qgraupel = NCDF_VARID(id, 'QGRAUPEL') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qice = NCDF_VARID(id, 'QICE') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qnrain = NCDF_VARID(id, 'QNRAIN') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run
  id_qnice = NCDF_VARID(id, 'QNICE') ;; Pioggia esplicitamente risolta e accumulata dall'inzio del run

  id_t = NCDF_VARID(id, 'T') ;; Perturbazione della temperatura potenziale
  id_thm = NCDF_VARID(id, 'THM')     ;;; either 1) pert moist pot temp=(1+Rv/Rd Qv)*(theta)-T0, or 2) pert dry pot temp=t
  id_t00 = NCDF_VARID(id, 'T00') ;; Base state temperature (1 numero)
  id_p00 =  NCDF_VARID(id, 'P00') ;; Base state pressure (1 numero)

  id_swdown = NCDF_VARID(id, 'SWDOWN')
  id_glw = NCDF_VARID(id, 'GLW')
  id_hfx = NCDF_VARID(id, 'HFX')
  id_qfx = NCDF_VARID(id, 'QFX')

  if(id_swdown gt 0) then NCDF_VARGET, id, id_swdown, swdown
  if(id_glw gt 0) then NCDF_VARGET, id, id_glw, glw
  if(id_hfx gt 0) then NCDF_VARGET, id, id_hfx, hfx
  if(id_qfx gt 0) then NCDF_VARGET, id, id_qfx, qfx

  if(id_znu gt 0) then NCDF_VARGET, id, id_znu, znu
  if(id_znw gt 0) then NCDF_VARGET, id, id_znw, znw
  if(id_zs gt 0) then NCDF_VARGET, id, id_zs, zs

  if(id_u gt 0) then NCDF_VARGET, id, id_u, uu     ;;; vento zonale
  if(id_v gt 0) then NCDF_VARGET, id, id_v, vv     ;;; vento meridionale
  if(id_w gt 0) then NCDF_VARGET, id, id_w, ww     ;;; velocità verticale
  if(id_p gt 0) then NCDF_VARGET, id, id_p, press  ;;; perturbazione della pressione
  if(id_pb gt 0) then NCDF_VARGET, id, id_pb, pb    ;;; pressione di base
  if(id_ph gt 0) then NCDF_VARGET, id, id_ph, ph   ;;; perturbazione della geopotenziale
  if(id_phb gt 0) then NCDF_VARGET, id, id_phb, phb    ;;; geopotenziale di base

  if(id_z gt 0) then NCDF_VARGET, id, id_z, zeta    ;;; geopotenziale di base

  if(id_pc gt 0) then NCDF_VARGET, id, id_pc, pc  ;;; perturbazione della geopotenziale
  if(id_pcb gt 0) then NCDF_VARGET, id, id_pcb, pcb    ;;; geopotenziale di base

  if(id_lat gt 0) then NCDF_VARGET, id, id_lat, xlat
  if(id_lon gt 0) then NCDF_VARGET, id, id_lon, xlon
  if(id_latu gt 0) then NCDF_VARGET, id, id_latu, xlat_u
  if(id_lonu gt 0) then NCDF_VARGET, id, id_lonu, xlon_u
  if(id_latv gt 0) then NCDF_VARGET, id, id_latv, xlat_v
  if(id_lonv gt 0) then NCDF_VARGET, id, id_lonv, xlon_v
  if(id_landmask gt 0) then NCDF_VARGET, id, id_landmask, xland_mask
  if(id_topo gt 0) then NCDF_VARGET, id, id_topo, xtopo
  if(id_rainc gt 0) then NCDF_VARGET, id, id_rainc, rainc
  if(id_rainnc gt 0) then NCDF_VARGET, id, id_rainnc, rainnc
  if(id_rainnc gt 0) then NCDF_VARGET, id, id_rainsh, rainsh

  if(id_ztd gt 0) then NCDF_VARGET, id, id_ztd, ztd
  if(id_ztd_dry gt 0) then NCDF_VARGET, id, id_ztd_dry, ztd_dry


  if(id_sst gt 0) then begin
    NCDF_VARGET, id, id_sst, sst    ;;; sst (definita al centro della griglia
    indx=where(sst le 0., count)
    sst[indx]=amiss
  endif
  if(id_pbl gt 0) then NCDF_VARGET, id, id_pbl, pblh    ;;; altezza dello strato limite (definita al centro della griglia)

  if(id_u10 gt 0) then NCDF_VARGET, id, id_u10, u10    ;;; velocità del vento u a 10 m
  if(id_v10 gt 0) then NCDF_VARGET, id, id_v10, v10    ;;; velocità del vento v a 10 m
  if(id_psfc gt 0) then NCDF_VARGET, id, id_psfc, psfc    ;;; velocità del vento v a 10 m
  if(id_t2 gt 0) then NCDF_VARGET, id, id_t2, t2    ;;; temperatura a 2 metri
  if(id_q2 gt 0) then NCDF_VARGET, id, id_q2, q2    ;;; mixing ratio a 2 metri

  ;;;;; microfisica
  if(id_qvapor gt 0) then NCDF_VARGET, id, id_qvapor, qvapor
  if(id_qice gt 0) then NCDF_VARGET, id, id_qice, qice
  if(id_qsnow gt 0) then NCDF_VARGET, id, id_qsnow, qsnow
  if(id_qcloud gt 0) then NCDF_VARGET, id, id_qcloud, qcloud

  if(id_qgraupel gt 0) then CDF_VARGET, id, id_qgraupel, qgraupel
  if(id_qrain gt 0) then NCDF_VARGET, id, id_qrain, qrain
  if(id_qnrain gt 0) then NCDF_VARGET, id, id_qnrain, qnrain
  if(id_qnice gt 0) then NCDF_VARGET, id, id_qnice, qnice

  if(id_u10 gt 0) then NCDF_VARGET, id, id_u10, u10
  if(id_v10 gt 0) then NCDF_VARGET, id, id_v10, v10
  if(id_t2 gt 0) then NCDF_VARGET, id, id_t2, t2
  if(id_q2 gt 0) then NCDF_VARGET, id, id_q2, q2

  if(id_t gt 0) then NCDF_VARGET, id, id_t, temp_p
  if(id_thm gt 0) then NCDF_VARGET, id, id_thm, thm
  if(id_t00 gt 0) then begin
    NCDF_VARGET, id, id_t00, t00
    t00=300.
  endif
  if(id_p00 gt 0) then NCDF_VARGET, id, id_p00, p00

  if(id_c3f gt 0) then NCDF_VARGET, id, id_c3f, c3f
  if(id_c4f gt 0) then NCDF_VARGET, id, id_c4f, c4f
  if(id_c3h gt 0) then NCDF_VARGET, id, id_c3h, c3h
  if(id_c4h gt 0) then NCDF_VARGET, id, id_c4h, c4h
  if(id_p_sfc gt 0) then NCDF_VARGET, id, id_p_sfc, p_sfc
  if(id_p_top gt 0) then NCDF_VARGET, id, id_p_top, p_top

  nz_aux=n_elements(c3f)
  nx_aux=n_elements(p_sfc(*,0))
  ny_aux=n_elements(p_sfc(0,*))

  ;t3d=(thm-temp_p)

  print,nx_aux,ny_aux,nz_aux
  press_hpa=fltarr(nx_aux,ny_aux,nz_aux)

  theta00=t00*(p00/100000.)^rovercp

  ;print,temp_p(nx_aux/2,ny_aux/2,*)
  ;stop
  ;;; calcola la coordinata verticale di pressione.
  for k=0,nz_aux-1 do begin
    for j=0,ny_aux-1 do begin
      for i=0,nx_aux-1 do begin
        press_hpa(i,j,k)=0.01*((c3f(k)*(p_sfc(i,j)-p_top)+c4f(k)+p_top))
        ;      print,i,j,k,press_hpa(i,j,k)
      endfor
    endfor
  endfor

  nz_aux=n_elements(c3h)
  nx_aux=n_elements(p_sfc(*,0))
  ny_aux=n_elements(p_sfc(0,*))

  xtn=fltarr(nx_aux)
  ytn=fltarr(ny_aux)

  xtn(0)=0.
  for i=1,nx_aux-1 do begin
    xtn(i)=xtn(i-1)+delta_x
  endfor

  ytn(0)=0.
  for i=1,ny_aux-1 do begin
    ytn(i)=ytn(i-1)+delta_x
  endfor

  press_hpa_half=fltarr(nx_aux,ny_aux,nz_aux)

  ;;; calcola la coordinata verticale di pressione.
  for k=0,nz_aux-1 do begin
    for j=0,ny_aux-1 do begin
      for i=0,nx_aux-1 do begin
        press_hpa_half(i,j,k)=0.01*((c3h(k)*(p_sfc(i,j)-p_top)+c4h(k)+p_top))
        ;      print,i,j,k,press_hpa(i,j,k)
      endfor
    endfor
  endfor

  geopot=ph+phb     ;; geopotenziale
  ;p_hpa=press+pb    ;; pressione in Pa
  ;p_hpa=press_hpa_half
  zgeo=(phb+ph)/grav  ;; altezza di geopotenziale [m]

  ;print,size(p_hpa)
  p_hpa=(pb+press)/100.    ;; pressione in hPa
  ;p_hpa=press_hpa

  ;p_hpa=(pb)/100.    ;; pressione in hPa
  ;p_sfc_d=pc+pcb

  ;nz_aux=n_elements(c4h)

  ;;;; si definiscono le varie dimensioni che servono a creare la struttura.
  if(id_lat gt 0) then begin
    aux=size(XLAT)
    if(aux(0) eq 2) then begin
      ny=aux(1)
      nx=aux(2)
    endif
  endif

  if(id_u gt 0) then begin
    aux=size(uu)
    if(aux(0) eq 3) then begin
      nzm1=aux(3)
      nz=nzm1+1
      ny_u=aux(2)
      nx_u=aux(1)
    endif
  endif

  if(id_v gt 0) then begin
    aux=size(vv)
    if(aux(0) eq 3) then begin
      ny_v=aux(2)
      nx_v=aux(1)
    endif
  endif

  ;print,zgeo(nx/2,ny/2,*)
  ;stop

  aux=size(zs)
  nzs=aux(1)

  theta=t00+temp_p  ;;;thm   ;temp_p    ;;; thm
  temp=theta*((press_hpa_half/1000.)^rovercp)
  ;temp=theta*((p_hpa/1000.)^rovercp)

  glat=fltarr(nx,ny)
  glat=(xlat)

  glon=fltarr(nx,ny)
  glon=(xlon)

  glat_u=fltarr(nx,ny)
  glat_u=(xlat_u)

  glon_u=fltarr(nx,ny)
  glon_u=(xlon_u)

  glat_v=fltarr(nx,ny)
  glat_v=(xlat_v)

  glon_v=fltarr(nx,ny)
  glon_v=(xlon_v)

  landmask=fltarr(nx,ny)
  landmask=abs(2.-(xland_mask))

  topo=fltarr(nx,ny)
  topo=(xtopo)
  ;print,qvapor

  if(ifile eq 0) then begin   ;; al primo passaggio si crea la struttura
    bckg_wrf=create_struct(NAME='wrf_out','znu',fltarr(nzm1),'znw',fltarr(nz),'rh',fltarr(nx,ny,nzm1,nfile),'plev_hpa',fltarr(nx,ny,nzm1,nfile),   $
      'uu',fltarr(nx_u,ny_u,nzm1,nfile),'vv',fltarr(nx_v,ny_v,nzm1,nfile),'ww',fltarr(nx,ny,nz,nfile),'qvapor',fltarr(nx,ny,nzm1,nfile),   $
      'qcloud',fltarr(nx,ny,nzm1,nfile),'qice',fltarr(nx,ny,nzm1,nfile),'qrain',fltarr(nx,ny,nzm1,nfile),'qgraupel',fltarr(nx,ny,nzm1,nfile),  $
      'qsnow',fltarr(nx,ny,nzm1,nfile),'zgeo',fltarr(nx,ny,nz,nfile),'p_hpa',fltarr(nx,ny,nz,nfile),'temp',fltarr(nx,ny,nzm1,nfile),   $
      'theta',fltarr(nx,ny,nzm1,nfile),'dbz',fltarr(nx,ny,nzm1,nfile),'topo',fltarr(nx,ny),'landmask',fltarr(nx,ny),'sst',fltarr(nx,ny,nfile),'pblh',fltarr(nx,ny,nfile),   $
      'rainc',fltarr(nx,ny,nfile),'rainnc',fltarr(nx,ny,nfile),'rainsh',fltarr(nx,ny,nfile),'psfc',fltarr(nx,ny,nfile),   $
      'u10',fltarr(nx,ny,nfile),'v10',fltarr(nx,ny,nfile),'hfx',fltarr(nx,ny,nfile),'qfx',fltarr(nx,ny,nfile),'glw',fltarr(nx,ny,nfile),   $
      'slp',fltarr(nx,ny,nfile), 'swdown',fltarr(nx,ny,nfile),'ztd',fltarr(nx,ny,nfile),'ztd_dry',fltarr(nx,ny,nfile),'p_hpa_half',fltarr(nx,ny,nzm1,nfile))
  endif

  bckg_wrf.znu[*]=znu[*]
  bckg_wrf.znw[*]=znw[*]
  bckg_wrf.topo[*,*]=topo[*,*]
  bckg_wrf.landmask[*,*]=landmask[*,*]

  bckg_wrf.sst[*,*,ifile]=sst[*,*]
  bckg_wrf.pblh[*,*,ifile]=pblh[*,*]
  bckg_wrf.rainc[*,*,ifile]=rainc[*,*]
  bckg_wrf.rainnc[*,*,ifile]=rainnc[*,*]
  bckg_wrf.rainsh[*,*,ifile]=rainsh[*,*]

  bckg_wrf.uu[*,*,*,ifile]=uu[*,*,*]
  bckg_wrf.vv[*,*,*,ifile]=vv[*,*,*]
  bckg_wrf.ww[*,*,*,ifile]=ww[*,*,*]

  if(id_ztd gt 0) then bckg_wrf.ztd[*,*,ifile]=ztd[*,*]
  if(id_ztd_dry gt 0) then bckg_wrf.ztd_dry[*,*,ifile]=ztd_dry[*,*]

  if(id_qrain gt 0) then bckg_wrf.qrain[*,*,*,ifile]=qrain[*,*,*]
  if(id_qcloud gt 0) then bckg_wrf.qcloud[*,*,*,ifile]=qcloud[*,*,*]
  if(id_qice gt 0) then bckg_wrf.qice[*,*,*,ifile]=qice[*,*,*]
  if(id_qgraupel gt 0) then bckg_wrf.qgraupel[*,*,*,ifile]=qgraupel[*,*,*]
  if(id_qsnow gt 0) then bckg_wrf.qsnow[*,*,*,ifile]=qsnow[*,*,*]
  if(id_qvapor gt 0) then bckg_wrf.qvapor[*,*,*,ifile]=qvapor[*,*,*]
  if(id_u10 gt 0) then bckg_wrf.u10[*,*,ifile]=u10[*,*]
  if(id_v10 gt 0) then bckg_wrf.v10[*,*,ifile]=v10[*,*]
  if(id_psfc gt 0) then bckg_wrf.psfc[*,*,ifile]=psfc[*,*]

  if(id_swdown gt 0) then bckg_wrf.swdown[*,*,ifile]=swdown[*,*]
  if(id_glw gt 0) then bckg_wrf.glw[*,*,ifile]=glw[*,*]
  if(id_hfx gt 0) then bckg_wrf.hfx[*,*,ifile]=hfx[*,*]
  if(id_qfx gt 0) then bckg_wrf.qfx[*,*,ifile]=qfx[*,*]

  bckg_wrf.theta[*,*,*,ifile]=theta[*,*,*]
  bckg_wrf.temp[*,*,*,ifile]=temp[*,*,*]
  bckg_wrf.p_hpa[*,*,*,ifile]=press_hpa[*,*,*]
  bckg_wrf.zgeo[*,*,*,ifile]=zgeo[*,*,*]
  bckg_wrf.p_hpa_half[*,*,*,ifile]=press_hpa_half[*,*,*]   ;p_hpa[*,*,*]   ; press_hpa_half[*,*,*] ;p_hpa[*,*,*]
  if(id_ztd gt 0) then begin
    bckg_wrf.ztd[*,*,ifile]=ztd[*,*]
    bckg_wrf.ztd_dry[*,*,ifile]=ztd_dry[*,*]
  endif else begin
    bckg_wrf.ztd[*,*,ifile]=amiss          ;;; serve per compatibilità con le versioni di WRF che non hanno ztd
    bckg_wrf.ztd_dry[*,*,ifile]=amiss
  endelse

  bckg_wrf.plev_hpa[*,*,*,ifile]=p_hpa[*,*,*]

  return
  aux_2d=fltarr(nx,ny)
  aux_p=cp*(bckg_wrf.p_hpa_half(*,*,*,ifile)/p00)^rovercp
  RAMS_comp_slpress,nx,ny,nzm1,bckg_wrf.theta(*,*,*,ifile),aux_p,   $
    bckg_wrf.zgeo(*,*,*,ifile),aux_2d

  scr=fltarr(nx,ny,nzm1)

  qgp=bckg_wrf.qgraupel[*,*,*,ifile]
  qvp=bckg_wrf.qvapor[*,*,*,ifile]
  qra=bckg_wrf.qrain[*,*,*,ifile]
  qsn=bckg_wrf.qsnow[*,*,*,ifile]
  tmk=bckg_wrf.temp[*,*,*,ifile]
  prs=bckg_wrf.p_hpa_half[*,*,*,ifile]*100.

  ;print,tmk(nx/2,ny/2,*)
  ;print,''
  ;print,temp_p(nx/2,ny/2,*)

  compute_dbz,scr,qvp,qgp,qsn,qra,tmk,prs,nx,ny,nzm1

  bckg_wrf.dbz[*,*,*,ifile]=scr
  bckg_wrf.slp(*,*,ifile)=aux_2d(*,*)

  ic=0L
  ep1=0.6222
  ep2=611.73
  To=273.15
  Rv=461.5
  LVo=2.501E+06
  for k=0,nzm1-1 do begin
    for j=0,ny-1 do begin
      QVAPX=bckg_wrf.qvapor[*,j,k,ifile]
      PRESSX=1.E2*p_hpa[*,j,k]
      TEMPX=temp[*,j,k]

      rhx=dblarr(nx)
      DCOMPUTERH,QVAPX,PRESSX,TEMPX,RHX,NX
      bckg_wrf.rh[*,j,k,ifile]=RHX[*]
      ; stop
      ;;;;; MODALITA' RAMS
      ;   for i=0,nx-1 do begin
      ;      t_virtual=tmk(i,j,k)+0.608*qvp(i,j,k)
      ;      rslif,prs(i,j,k),tmk(i,j,k),amiss,x1

      ;      qv_sat=(ep1/prs(i,j,k))*(ep2*exp((LVo/Rv)*((1./To)-(1./(tmk(i,j,k))))))

      ;      if(qvp(i,j,k) gt 1.000*x1 ) then begin
      ;;     print,i,j,k,prs(i,j,k),t_virtual,qvp(i,j,k),x1,qv_sat,qvp(i,j,k)/x1
      ;;       stop
      ;      bckg_wrf.qvapor[i,j,k,ifile]=x1              ;; riduco il mixing ratio al valore di saturazione
      ;      qvp(i,j,k)=x1
      ;      ic=ic+1L
      ;      endif

      ;;      ;  print,i,j,k,rams_press(i,j,k)*100.,bckg.t(i,j,k,ifile),x1,bckg.rv(i,j,k,ifile)
      ;      bckg_wrf.rh[i,j,k,ifile]=100.*qvp(i,j,k)/x1

      ;;      if( bckg.rh(i,j,k,ifile) gt 100.) then  begin
      ;;        ;      print,'RH > 100.',bckg.rh(i,j,k,ifile)
      ;;        bckg.rh(i,j,k,ifile)=100.
      ;;      endif
      ;;      if( bckg.rh(i,j,k,ifile) le 0.) then begin
      ;;        ;   print,'RH minore di 0.',i,j,k,bckg.rh(i,j,k,ifile),rams_press(i,j,k)*100.,bckg.t(i,j,k,ifile),vapor(i,j,k),x1
      ;;        bckg.rh(i,j,k,ifile)=0.
      ;;      endif
      ;    endfor
    endfor
  endfor

  indx=where(bckg_wrf.rh gt 100.01, count)
  print,'Umidita'' relativa > 100.',count,max(bckg_wrf.rh[*,*,*,ifile])

  print,'Valori di qvapor ridotti alla saturazione: ',ic

  ;indx=where(qgraupel*1.e3 gt 0., count)
  ;if(count gt 0.) then begin
  ;print,count
  ;stop
  ;endif

  return
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro date_add,date_in=date_ini,delta_h=delta_h,date_out=date_out

  ;;; Questo programma somma le ore delta_h alla data iniziale (date_ini).
  ;;; La data iniziale e finale (date_out) hanno 14 cifre.

  year=strmid(date_ini,0,4)
  month=strmid(date_ini,4,2)
  day=strmid(date_ini,6,2)
  hour=strmid(date_ini,8,2)
  minute=strmid(date_ini,10,2)
  second=strmid(date_ini,12,2)

  jul_day = JULDAY(Month, Day, Year, Hour, Minute, Second)

  jul_day=jul_day+delta_h/24.d0

  CALDAT, Jul_day, Month, Day, Year, Hour,minute,second

  date_out=string(year,'(I4.4)')+string(month,'(I2.2)')+string(day,'(I2.2)')+string(hour,'(I2.2)')+string(minute,'(I2.2)')+string(second,'(I2.2)')

  return
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro compute_dbz,scr,qvp,qgp,qsn,qra,tmk,prs,n1,n2,n3

  ;; qvp water vapour mixing ratio (kg/kg)
  ;; qgp graupel  mixing ratio (kg/kg)
  ;; tmk air temperature
  ;; prs pressure (Pa)
  ;; qra rain mixing ratio (kg/kg)
  ;
  ;      This routine computes equivalent reflectivity factor (in dBZ) at
  ;       each model grid point.  In calculating Ze, the RIP algorithm makes
  ;       assumptions consistent with those made in an early version
  ;       (ca. 1996) of the bulk mixed-phase microphysical scheme in the MM5
  ;       model (i.e., the scheme known as "Resiner-2").  For each species:
  ;
  ;       1. Particles are assumed to be spheres of constant density.  The
  ;       densities of rain drops, snow particles, and graupel particles are
  ;       taken to be rho_r = rho_l = 1000 kg m^-3, rho_s = 100 kg m^-3, and
  ;       rho_g = 400 kg m^-3, respectively. (l refers to the density of
  ;       liquid water.)
  ;
  ;       2. The size distribution (in terms of the actual diameter of the
  ;       particles, rather than the melted diameter or the equivalent solid
  ;       ice sphere diameter) is assumed to follow an exponential
  ;       distribution of the form N(D) = N_0 * exp( lambda*D ).
  ;
  ;       3. If ivarint=0, the intercept parameters are assumed constant (as
  ;       in early Reisner-2), with values of 8x10^6, 2x10^7, and 4x10^6 m^-4,
  ;       for rain, snow, and graupel, respectively.  If ivarint=1, variable
  ;       intercept parameters are used, as calculated in Thompson, Rasmussen,
  ;       and Manning (2004, Monthly Weather Review, Vol. 132, No. 2, pp. 519-542.)
  ;
  ;       More information on the derivation of simulated reflectivity in RIP
  ;       can be found in Stoelinga (2005, unpublished write-up).  Contact
  ;       Mark Stoelinga (stoeling@atmos.washington.edu) for a copy.
  ; ----------- n1=nx; n2=ny; n3=nz

  r1 = 1.e-15
  ron = 8.e6
  ron2 = 1.e10
  son = 2.e7
  gon = 5.e7
  ron_min = 8.e6
  ron_qr0 = 0.00010
  ron_delqr0 = 0.25*ron_qr0
  ron_const1r = (ron2-ron_min)*0.5
  ron_const2r = (ron2+ron_min)*0.5

  gamma_seven = 720.
  rho_r = 1000.           ; 1000. kg m^-3
  rhowat = 1000.           ; 1000. kg m^-3
  rho_s = 100.             ; kg m^-3
  rho_g = 400.             ; kg m^-3
  alpha = 0.224

  t00=273.15
  CELKEL=t00
  rgas=287.
  Rd=rgas

  factor_r = gamma_seven * 1.e18 * (1./(!PI*rho_r))^1.75
  factor_s = gamma_seven * 1.e18 *((1./(!PI*rho_s))^1.75) * ((rho_s/RHOWAT)^2) * alpha
  factor_g = gamma_seven * 1.e18 * ((1./(!PI*rho_g))^1.75) * ((rho_g/RHOWAT)^2) * alpha

  for k = 0,n3-1 do begin
    for j = 0,n2-1 do begin
      for i = 0,n1-1 do begin

        virtualx=0.
        virtual,tmk(i,j,k),qvp(i,j,k),virtualx
        ;print,tmk(i,j,k),qvp(i,j,k),virtualx
        rhoair=prs(i,j,k)/ ( Rd*virtualx )  ; air density

        ;print,i,j,k,rhoair

        IF (tmk(i,j,k) gt CELKEL) THEN begin
          factorb_s=factor_s/alpha
          factorb_g=factor_g/alpha
        endif else begin
          factorb_s=factor_s
          factorb_g=factor_g
        ENDelse

        temp_c = -0.001 < (tmk(i,j,k)-CELKEL)
        sonv   = 2.0e8 < 2.0e6*exp(-0.12*temp_c)

        ;print,temp_c,(tmk(i,j,k)-CELKEL), son

        gonv = gon
        IF (qgp(i,j,k) gt r1) THEN begin
          gonv = 2.38*(!PI*rho_g/(rhoair*qgp(i,j,k)))^0.92
          gonv = 1.e4 > (gonv < gon)
        ENDIF

        ronv = ron2
        IF (qra(i,j,k) gt r1) THEN begin
          ronv = ron_const1r*tanh((ron_qr0-qra(i,j,k))/ron_delqr0) + ron_const2r
        ENDIF

        ;      Total equivalent reflectivity factor (z_e, in mm^6 m^-3) is
        ;      the sum of z_e for each hydrometeor species:

        z_e =   factor_r  * (rhoair*qra(i,j,k))^1.75 /ronv^.75   $
          + factorb_s * (rhoair*qsn(i,j,k))^1.75 /sonv^.75   $
          + factorb_g * (rhoair*qgp(i,j,k))^1.75 /gonv^.75

        ;      Adjust small values of Z_e so that dBZ is no lower than -30
        indices=where(z_e lt 0.001, /NULL)
        z_e(indices)=0.001
        ;      Convert to dBZ
        SCR(i,j,k) = 10. * alog10(z_e)
        ;if(z_e gt 10.) then begin
        ;  print,factor_r,factor_s,factor_g
        ;print,k,z_e,alog10(z_e),qra(i,j,k),qsn(i,j,k),qgp(i,j,k),rhoair
        ;endif

        ;                       if(scr(i,j,k) .gt. 30.) then
        ;           print*,'scr...',i,j,k,rhoair,scr(i,j,k),z_e
        ;                  endif
      ENDfor
    ENDfor
  ENDfor

  return
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro virtual,tmp,rmix,virtualx
  ;      This function returns virtual temperature in K, given temperature
  ;      in K and mixing ratio in kg/kg.

  virtualx=0.

  virtualx=tmp*(0.622+rmix)/(0.622*(1.+rmix))

  return
END


;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
pro calcola_lcl,nz,rv,temp,press,zeta,amiss,xlcl

  ;integer :: nz
  ;real :: press(nz),temp(nz),rv(nz),zeta(nz)
  ;real :: amiss,xlcl,rv_sat

  ;print,''
  ;print,press(*)
  ;print,''
  ;print,temp(*)

  for k=0,nz-1 do begin
    rslif,press(k),temp(k),amiss,rv_sat
    if(0.5*(rv(0)+rv(1)) gt rv_sat) then begin
      xlcl=zeta(k)
      break
    endif
    ;print,rv_sat,0.5*(rv(1)+rv(2)),k
  endfor


  return
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro DCOMPUTERH,QV,P,T,RHX,NX

  ;DOUBLE PRECISION QV(NX),P(NX),T(NX),RH(NX)
  SVP1=0.6112D0 & SVP2=17.67D0 & SVP3=29.65D0 & SVPT0=273.15D0
  R_D=287.D0 & R_V=461.6D0  & EP_2=R_D/R_V
  EP_3=0.622D0
  ;  RHX=DBLARR(NX)
  FOR I = 0,NX-1 do begin
    PRESSURE = P(I)
    TEMPERATURE = T(I)
    ;c       es  = 1000.*svp1*
    ES = 10.D0*SVP1*EXP(SVP2* (TEMPERATURE-SVPT0)/    $
      (TEMPERATURE-SVP3))
    ;c       qvs = ep_2*es/(pressure-es)
    QVS = EP_3*ES/ (0.01D0*PRESSURE- (1.D0-EP_3)*ES)
    ;c        rh = 100*amax1(1., qv(i)/qvs)
    ;c       rh(i) = 100.*qv(i)/qvs
    RHX(I) = 100.D0*((QV(I)/QVS < 1.0D0)  > 0.0D0) ; DMAX1(DMIN1(QV(I)/QVS,1.0D0),0.0D0)
  ENDFOR

  RETURN
END

;----------------------------------------------------------------------
pro RAMS_comp_slpress,n1,n2,n3,theta,pp,z,slp,zeta=zeta

  ; This subroutine calculates the pressure at level zlev. it
  ;   is hardwired here to calculate mean sea level pressure,
  ;   but can be easily changed to calculate pressure at any level
  ;   by just changing zlev.
  ;   A standard atmosphere lapse rate of 6.5 c/km is used to
  ;   interpolate temperature down from level 2 in the model.
  ; Input are: theta=potenrial temperature in [K]
  ;             pp=pressure (Exner Function pp=cp*(p/p0)^r/cp [J/kgK]
  ;             z=geopotential height [m]
  ; slp(n1,n2), theta(n1,n2,n3),pp(n1,n2,n3),z(n1,n2,n3)

  ;print,n1,n2,n3

  ;print,theta

  sl_p00=1000.
  sl_g=9.8
  sl_cp=1004.
  sl_r=287.
  sl_cpor=sl_cp/sl_r
  ;rlap=-.0065   ; standard temp lapse rate
  rlap=.0025     ; approx standard theta lapse rate
  if(arg_present(zeta_ref)) then begin
    zlev=zeta_ref
  endif else begin
    zlev=0.
  endelse

  for j=0,n2-1 do begin
    for i=0,n1-1 do begin
      for k=1,n3-1 do begin
        if(z(i,j,k) ge zlev) then begin
          ktop=k
          kbot=k-1
          goto, j31
        endif
      endfor

      j31:

      ;if(i.eq.1.and.j.eq.1)  &
      ;   print*,'kbot:',kbot,ktop,z(i,j,kbot),z(i,j,ktop)  &
      ;         ,pp(i,j,kbot),theta(i,j,kbot)
      ddz=zlev-z(i,j,kbot)
      if(zlev lt z(i,j,kbot)) then begin
        thbar=(theta(i,j,kbot)-.5*ddz*rlap)
      endif else begin
        thbar=.5*(theta(i,j,kbot)+theta(i,j,ktop))
      endelse
      slp(i,j)=pp(i,j,kbot)-ddz*sl_g/thbar
      slp(i,j)=(slp(i,j)/sl_cp)^sl_cpor*sl_p00
      if(slp(i,j) gt 1100.) then $
        print,i,j,slp(i,j),thbar,kbot,ktop,ddz,theta(i,j,kbot),zlev,z(i,j,kbot),pp(i,j,kbot),ddz*sl_g/thbar
    endfor
  endfor


  return
end

